<?php
/**
* SimpleACL Component
* @version 1.0
* @package SimpleACL
* @copyright (C) 2007 by Alessandro Pasotti - All rights reserved!
* @license GNU AFFERO GENERAL PUBLIC LICENSE - AGPL V.3
**/


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
require_once( $mosConfig_absolute_path."/administrator/components/com_simpleacl/class.simpleacl.php");
require_once( $mainframe->getPath( 'admin_html' ) );


if( !@include_once( $mosConfig_absolute_path ."/administrator/components/com_simpleacl/language/$mosConfig_lang.messages.php" ) ) {
    include_once( $mosConfig_absolute_path ."/administrator/components/com_simpleacl/language/english.messages.php" );
}


$act = mosGetParam($_POST, 'act', '');
$cid = mosGetParam($_REQUEST, 'cid', '');

switch ($task) {

  ##############################################

  case "about":
    showAbout();
    break;

  ##############################################

  case "settings":
    showConfig( $option );
    break;

  case "savesettings":
    $ac_sectionlist   = implode(',',$acselections);
    saveConfig ( $option );
    //saveConfig ($option, $ac_autopublish, $ac_anonentry, $ac_sorting, $ac_bbcodesupport, $ac_picsupport, $ac_smiliesupport, $ac_notify, $ac_notify_email, $ac_openingmode, $ac_pagination, $ac_perpage, $ac_formposition, $ac_regedit, $ac_mainmode, $ac_sectionlist);
    break;


    case 'edit':
        editItem( $option, $cid[0] );
        break;

    case 'new':
        editItem( $option, 0 );
        break;

    case 'save':
        saveItem( $option );
        break;

  case "remove":
    removeItems( $cid, $option );
    break;

    default:
    case 'items':
        showItems( $option );
    break;
}
?>



<div align="center" class="footer">
    <table width="99%" border="0">
    <tr>
        <td align="center">
            <div align="center">
                <?php echo "SimpleACL"; ?>
            </div>
            <div align="center" class="smallgrey">
                <?php echo "&copy Copyright " . date('Y') . " by Alessandro Pasotti"; ?>
            </div>
        </td>
    </tr>
    </table>
</div>
<?php


############################################################################

function editItem ( $option, $uid ) {
    global $database, $mainframe, $my;

    $row = new mosSimpleACL( $database );
    $row->load( $uid );

    /*
    // Prepare user list, exclude existing ACLS
    $database->setQuery( "SELECT userid FROM #__simpleacl");
    $aclusers = $database->loadObjectList();
    if(count($aclusers)){
        //var_dump($aclusers);
        foreach($aclusers as $u){
            if($u->userid != $row->userid){
                $_aclusers[] = $u->userid;
            }
        }
        //var_dump($_aclusers);
        if(count ($_aclusers)){
            $where = ' WHERE id NOT IN (' . join( ',', $_aclusers) . ') ';
        }
    }
    */

    //var_dump("SELECT * FROM #__users $where ORDER BY name");
    $database->setQuery( "SELECT * FROM #__users $where ORDER BY name");
    $acl = $database->loadObjectList();
    //var_dump($acl);
    $lists['users'] = mosHTML::selectList( $acl, 'userid', 'class="inputbox" size="1"', 'id', 'name', intval( $row->userid ) );


    // Get section list
    $lists['sections'] = mosAdminMenus::SelectSection( 'sectionid', $row->sectionid, $javascript );

    # Check if new or edit
    if ($uid) {
        $row->checkout( $my->id );
    }
    HTML_SimpleACL::editItem( $option, $row, $lists);
}


############################################################################

function showItems ( $option ) {
  global $database, $mainframe;
  $limit      = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
  $limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

  $database->setQuery( "SELECT count(*) FROM #__simpleacl AS a" . (count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "") );
  $total = $database->loadResult();
  echo $database->getErrorMsg();
  include_once( "includes/pageNavigation.php" );
  $pageNav = new mosPageNav( $total, $limitstart, $limit  );

  $database->setQuery( "SELECT #__simpleacl.*, u.name as name, CONCAT(s.name, ' (' , s.title, ')') as sectionname FROM #__simpleacl, #__users as u, #__sections AS s WHERE #__simpleacl.userid = u.id AND #__simpleacl.sectionid = s.id"
    . "\nORDER BY name ASC"
    . "\nLIMIT $pageNav->limitstart,$pageNav->limit"
  );
  $rows = $database->loadObjectList();
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return false;
  }

  HTML_SimpleACL::showItems( $option, $rows, $search, $pageNav );

}


############################################################################

function saveItem ( $option ) {
    global $database;
    $row = new mosSimpleACL( $database );

    // First check unique on insert
    $userid       = $_POST['userid'];
    $sectionid    = $_POST['sectionid'];
    //var_dump($_POST);
    if(!$_REQUEST['id'] && $userid && $sectionid){
        $database->setQuery( "SELECT id FROM #__simpleacl WHERE #__simpleacl.userid = $userid AND #__simpleacl.sectionid = $sectionid");
        $result = $database->loadResult();
        echo $database->getErrorMsg();
        if($result){
            mosRedirect("index2.php?option=$option&task=edit&amp;cid=$result&amp;error=_SACL_UNIQUE_ERR");
            return;
        }
    }

    $_POST['action'] = is_array($_POST['action']) ? join(',', $_POST['action']) : '';
    if (!$row->bind( $_POST )) {
        echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
    }
    if (!$row->store()) {
        echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
    }
    mosRedirect( "index2.php?option=$option&task=items" );
}



############################################################################

function removeItems( $cid, $option ) {
  global $database;
  if (count( $cid )) {
    $cids = implode( ',', $cid );
    $database->setQuery( "DELETE FROM #__simpleacl WHERE id IN ($cids)" );
    if (!$database->query()) {
         echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
         exit();
    }

  }
  if($msg){
    echo ( "<script> alert('".$msg."'); window.history.go(-1);</script>\n");
    exit();
  }
  mosRedirect( "index2.php?option=$option&task=items" );
}



############################################################################
/**
* About page
*/
function showAbout(){
    HTML_SimpleACL::showAbout();
}

/**
* Config page
* @todo validation
*/
function showConfig( $option ) {
  global $mosConfig_live_site, $mosConfig_absolute_path, $database;
  require($mosConfig_absolute_path."/administrator/components/com_simpleacl/config.simpleacl.php");
?>
    <script language="javascript" type="text/javascript">
    function submitbutton(pressbutton) {
      var form = document.adminForm;
      <?php getEditorContents( 'editor1', 'denytext' ) ; ?>
      submitform( pressbutton );
    }
    </script>

  <form action="index2.php" method="POST" name="adminForm">
  <table width="29%" class="adminheading">
    <tr>
    <td width="100%">
       <span class="sectionname">SimpleACL Settings</span>
    </td>
    </tr>
  </table>
  <table cellpadding="4" cellspacing="0" border="0" width="100%" >
  <tr>
  <td width="100%">
    <fieldset><legend><?php echo _SACL_DEF_POLICY ?></legend>
          <input type="checkbox" name="default_policy[]" value="a" <?php if(strpos($default_policy, 'a') !== false) echo 'checked="true"'; ?> /><label for="access_c"><?php echo _SACL_C_DESC ?></label>
          <br />
          <input type="checkbox" name="default_policy[]" value="r" <?php if(strpos($default_policy, 'r') !== false) echo 'checked="true"'; ?> /><label for="access_r"><?php echo _SACL_R_DESC ?></label>
          <br />
          <input type="checkbox" name="default_policy[]" value="u" <?php if(strpos($default_policy, 'u') !== false) echo 'checked="true"'; ?> /><label for="access_u"><?php echo _SACL_U_DESC ?></label>
          <br />
          <input type="checkbox" name="default_policy[]" value="d" <?php if(strpos($default_policy, 'd') !== false) echo 'checked="true"'; ?> /><label for="access_d"><?php echo _SACL_D_DESC ?></label>
          </fieldset>
    </fieldset>
  <input type="hidden" name="option" value="<?php echo $option; ?>">
  <input type="hidden" name="act" value="<?php echo $act; ?>">
  <input type="hidden" name="task" value="">
 </td>
 </tr>
 <tr>
  <td><strong>Deny page text</strong><br />
            <?php
            // parameters : areaname, content, hidden field, width, height, rows, cols
            mosMakeHtmlSafe( $denytext );
            editorArea( 'editor1',  $denytext , 'denytext', '600', '400', '70', '15' ) ;
            ?>
</td></tr>
</table>
</form>
<?php
}


/**
* Save config
*/
function saveConfig ( $option ) {

  $configfile = "components/com_simpleacl/config.simpleacl.php";
  @chmod ($configfile, 0766);
  $permission = is_writable($configfile);
  if (!$permission) {
    $mosmsg = "Config file not writeable!";
    mosRedirect("index2.php?option=$option&act=config",$mosmsg);
    break;
  }

  $vars = array('default_policy', 'denytext');

  $config  = "<?php\n";

  foreach ( $_POST as $k=>$v ) {
     if (in_array($k,  $vars)){
        if(is_array($v)){
            $_v = join(',', $v);
        } else {
            $_v = $v;
        }
        $config .= "$".$k." = \"".$_v."\";\n";
     }
  }
  $config .= "?>";

  if ($fp = fopen("$configfile", "w")) {
    fputs($fp, $config, strlen($config));
    fclose ($fp);
  }
  mosRedirect("index2.php?option=$option&task=settings", "Settings saved");
}

?>